
#include "fpComplex.h"
#include "test.h"


using namespace std;

int main (int argc, char * const argv[])
{
	fp				x, y, z;
	clock_t			theTime;
		
	setDecPrec(2000);
	setBlockPrec(250); // use blockPrec = decPrec/8 unless blockPrec<8, then blockPrec++
	
	theTime = clock();
	x = Pi();
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken Pi = " << theTime << " microseconds" << endl << endl;
	cout << "Pi = " << x << endl << endl;
	
	theTime = clock();
	ComputeE(y);
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken e = " << theTime << " microseconds" << endl << endl;
	cout << "e = " << y << endl << endl; 
	
	theTime = clock();
	add(z, x, y);
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken add = " << theTime << " microseconds" << endl << endl;
	cout << "add = " << z << endl << endl;
	
	theTime = clock();
	sub(z, x, y);
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken sub = " << theTime << " microseconds" << endl << endl;
	cout << "sub = " << z << endl << endl;
	
	theTime = clock();
	mul(z, x, y);
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken mul = " << theTime << " microseconds" << endl << endl;
	cout << "mul = " << z << endl << endl;
	
	theTime = clock();
	div(z, x, y);
	theTime = clock() - theTime;
	theTime = (1e6)*(double)theTime/CLOCKS_PER_SEC;
	cout << "time taken div = " << theTime << " microseconds" << endl << endl;
	cout << "div = " << z << endl << endl;
	 
	return 0;
}
