/*
 *  main.cpp
 *  fp
 *
 *  Created by Robert Delaney on 9/21/2008.
 *  Copyright 2009 __Bob Delaney's Science Software__. All rights reserved.
 *
 */

#include "fpComplex.h"

using namespace std;

int main (int argc, char * const argv[])
{
	mb		x, y, z, n;
	fp		xf, yf, zf, one, oneThird;
	INT32	k;
	
	x = "123456789123456789123456789123456789123456789123456789123456789";
	y = "987654321987654321987654321987654321987654321";
	
	z = x + y;
	cout << "x + y = " << z << endl;
	z = x - y;
	cout << "x - y = " << z << endl;
	z = x*y;
	cout << "x*y = " << z << endl;
	cout << "x/y = " << x/y << endl;
	cout << "sqr(x) = " << sqr(x) << endl;
	cout << "sqrt(x) = " << sqrt(x) << endl;
	cout << "x^3 = " << (x^3) << endl;
	cout << "x^(1/3) = " << nthRoot(x, 3) << endl;
	cout << "gcd(x, y) = " << gcd(x, y) << endl;
	cout << "x mod y = " << x % y << endl;
	x = 1000;
	cout << "x! = " << factorial(x) << endl;
	y = 500;
	cout << "binomial(x, y) = " << binomial(x, y) << endl;
	
	x = 123456789;
	y = 987654321;
	k = 128;
	n = 246813579;
	cout << "x^(y*(2^k)) mod n = " << powerMod(x, y, k, n) << endl;
	/*
	 Output = 93731634  // Victor Shoup's NTL gives the same number.
	 Note that for this example in x^(y*(2^k)), the exponent of x is about 3.4 x 10^47.
	 So x raised to that exponent is about 10^(10^48). That's 1 followed by 10^48 zeroes.
	 No computer in existence can hold that number. Taking the mod allows the computer to
	 do the calculation gradually without ever generating the full number.
	 */
	
	x = "57345678987123487651234569846123567891123547";
	if(isItPrime(x, 35))  // uses powerMod in Miller-Rabin test
		cout << "true" << endl;
	else
		cout << "false" << endl;
	
	setDecPrec(64);
	setBlockPrec(8); // blockPrec = decPrec/8
	
	one = 1.;
	oneThird = one/3;  // oneThird = 1./3. will not have 64 decimal digit accuracy
	
	xf = "123.456e-24";
	yf = "2.73e27";
	
	zf = xf*yf;
	cout << "xf*yf = " << zf << endl;
	cout << "sqr(xf) = " << sqr(xf) << endl;
	cout << "sqrt(xf) = " << sqrt(xf) << endl;
	cout << "xf^3 = " << (xf^3) << endl;
	cout << "xf^(1/3) = " << (xf^oneThird) << endl;
	cout << "pi = " << Pi() << endl;
	
	xf = "1.3";
	cout << "exp(xf) = " << exp(xf) << endl;
	cout << "log(xf) = " << log(xf) << endl;
	cout << "sin(xf) = " << sin(xf) << endl;
	cout << "cos(xf) = " << cos(xf) << endl;
	cout << "tan(xf) = " << tan(xf) << endl;

	xf = ".456";
	cout << "asin(xf) = " << asin(xf) << endl;
	cout << "acos(xf) = " << acos(xf) << endl;
	cout << "atan(xf) = " << atan(xf) << endl;
	
	yf = ".654";
	cout << "atan2(yf, xf) = " << atan2(yf, xf) << endl;
	
	cout << "sinh(xf) = " << sinh(xf) << endl;
	cout << "cosh(xf) = " << cosh(xf) << endl;
	cout << "tanh(xf) = " << tanh(xf) << endl;
	cout << "asinh(xf) = " << asinh(xf) << endl;
	xf = "1.456";
	cout << "acosh(xf) = " << acosh(xf) << endl;
	xf = ".456";
	cout << "atanh(xf) = " << atanh(xf) << endl;
	cout << "factorial(xf) = " << factorial(xf) << endl;  // Gamma(xf + 1)
	
    return 0;
}
